﻿
namespace ProjectDumpTruck;

public class EntityDumpTruck
{

    /// <summary>
    /// Скорость
    /// </summary>
    public int Speed { get; private set; }
    /// <summary>
    /// Вес
    /// </summary>
    public double Weight { get; private set; }
    /// <summary>
    /// Основной цвет
    /// </summary>
    public Color BodyColor { get; private set; }
    /// <summary>
    /// Дополнительный цвет (для опциональных элементов)
    /// </summary>
    public Color AdditionalColor { get; private set; }
    /// <summary>
    /// Признак (опция) наличие кузова
    /// </summary>
    public bool Awning { get; private set; }
    /// <summary>
    /// Признак (опция) наличия тента
    /// </summary>
    public bool Tent { get; private set; }
    /// <summary>
    /// Шаг перемещения автомобиля
    /// </summary>
    public double Step => Speed * 100 / Weight;
    /// <summary>
    /// Инициализация полей объекта-класса самосвала
    /// </summary>
    /// <param name="speed">Скорость</param>
    /// <param name="weight">Вес автомобиля</param>
    /// <param name="bodyColor">Основной цвет</param>
    /// <param name="additionalColor">Дополнительный цвет</param>
    /// <param name="awning">Признак наличия обвеса</param>
    /// <param name="tent">Признак наличия антикрыла</param>
    public void Init(int speed, double weight, Color bodyColor, Color
    additionalColor, bool awning, bool tent)
    {
        Speed = speed;
        Weight = weight;
        BodyColor = bodyColor;
        AdditionalColor = additionalColor;
        Awning = awning;
        Tent = tent;
    }
}
