﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace ProjectDumpTruck
{
    public partial class FormDumpTruck : Form

    {
        private DrawningDumpTruck? _drawningDumpTruck;


        public FormDumpTruck()
        {
            InitializeComponent();
        }

        private void Draw()
        {
            if (_drawningDumpTruck == null) return;

            Bitmap bmp = new(pictureBoxDumpTruck.Width,
            pictureBoxDumpTruck.Height);
            Graphics gr = Graphics.FromImage(bmp);
            _drawningDumpTruck.DrawTransport(gr);
            pictureBoxDumpTruck.Image = bmp;

        }

        private void ButtonCreate_Click(object sender, EventArgs e)
        {
            Random random = new();
            _drawningDumpTruck = new DrawningDumpTruck();
            _drawningDumpTruck.Init(random.Next(100, 300), random.Next(1000, 3000),
                Color.FromArgb(random.Next(0, 256), random.Next(0, 256), random.Next(0, 256)),
                Color.FromArgb(random.Next(0, 256), random.Next(0, 256), random.Next(0, 256)),
                Convert.ToBoolean(random.Next(0, 2)), Convert.ToBoolean(random.Next(0, 2)));

            _drawningDumpTruck.SetPictureSize(pictureBoxDumpTruck.Width, pictureBoxDumpTruck.Height);
            _drawningDumpTruck.SetPosition(random.Next(10, 100), random.Next(10, 100));

            Draw();
        }
        private void ButtonMove_Click(object sender, EventArgs e)
        {
            if (_drawningDumpTruck == null) return;

            string name = ((Button)sender)?.Name ?? string.Empty;
            bool result = false;
            switch (name)
            {
                case "buttonLeft":
                    result = _drawningDumpTruck.MoveTransport(DirectionType.Left); break;
                case "buttonDown":
                    result = _drawningDumpTruck.MoveTransport(DirectionType.Down); break;
                case "buttonUp":
                    result = _drawningDumpTruck.MoveTransport(DirectionType.Up); break;
                case "buttonRight":
                    result = _drawningDumpTruck.MoveTransport(DirectionType.Right); break;
            }

            if (result) Draw();

        }
    }
}
